'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

exports.default = extendable;

var _createExtendable = require('./util/createExtendable');

var _createExtendable2 = _interopRequireDefault(_createExtendable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function extendable(Base) {
  var emptyBase = new Base();

  var NAME = Base.prototype.constructor.name;
  var EMPTY = (0, _keys2.default)(new Base()).reduce(function (acc, key) {
    acc[key] = emptyBase[key];
    return acc;
  }, {});

  function copy(val, update) {
    for (var _iterator = (0, _keys2.default)(update), _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : (0, _getIterator3.default)(_iterator);;) {
      var _ref;

      if (_isArray) {
        if (_i >= _iterator.length) break;
        _ref = _iterator[_i++];
      } else {
        _i = _iterator.next();
        if (_i.done) break;
        _ref = _i.value;
      }

      var key = _ref;

      val[key] = update[key];
    }

    return val;
  }

  function empty(val) {
    return (0, _assign2.default)(val, EMPTY);
  }

  function ExtendableWrapper(val) {
    return this.__wrapImmutable(new Base(val));
  }

  ExtendableWrapper['is' + NAME] = function is(obj) {
    return obj && obj instanceof ExtendableWrapper;
  };

  ExtendableWrapper.prototype = (0, _createExtendable2.default)(Base, copy, empty);
  ExtendableWrapper.prototype.constructor = ExtendableWrapper;

  ExtendableWrapper.prototype.toString = function toString() {
    return 'Extendable.' + Base.prototype.toString.call(this);
  };

  return ExtendableWrapper;
}